Index: lemon/bellman_ford.h
===================================================================
--- lemon/bellman_ford.h	(revision 1337)
+++ lemon/bellman_ford.h	(revision 870)
@@ -1,7 +1,7 @@
-/* -*- mode: C++; indent-tabs-mode: nil; -*-
+/* -*- C++ -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library.
+ * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -30,5 +30,4 @@
 #include <lemon/maps.h>
 #include <lemon/path.h>
-#include <lemon/bits/stl_iterators.h>
 
 #include <limits>
@@ -37,5 +36,5 @@
 
   /// \brief Default OperationTraits for the BellmanFord algorithm class.
-  ///
+  ///  
   /// This operation traits class defines all computational operations
   /// and constants that are used in the Bellman-Ford algorithm.
@@ -44,5 +43,5 @@
   /// value is used as extremal infinity value.
   template <
-    typename V,
+    typename V, 
     bool has_inf = std::numeric_limits<V>::has_infinity>
   struct BellmanFordDefaultOperationTraits {
@@ -85,5 +84,5 @@
     }
   };
-
+  
   /// \brief Default traits class of BellmanFord class.
   ///
@@ -93,5 +92,5 @@
   template<typename GR, typename LEN>
   struct BellmanFordDefaultTraits {
-    /// The type of the digraph the algorithm runs on.
+    /// The type of the digraph the algorithm runs on. 
     typedef GR Digraph;
 
@@ -111,8 +110,8 @@
     /// \see BellmanFordDefaultOperationTraits
     typedef BellmanFordDefaultOperationTraits<Value> OperationTraits;
-
-    /// \brief The type of the map that stores the last arcs of the
+ 
+    /// \brief The type of the map that stores the last arcs of the 
     /// shortest paths.
-    ///
+    /// 
     /// The type of the map that stores the last
     /// arcs of the shortest paths.
@@ -121,6 +120,6 @@
 
     /// \brief Instantiates a \c PredMap.
-    ///
-    /// This function instantiates a \ref PredMap.
+    /// 
+    /// This function instantiates a \ref PredMap. 
     /// \param g is the digraph to which we would like to define the
     /// \ref PredMap.
@@ -137,6 +136,6 @@
     /// \brief Instantiates a \c DistMap.
     ///
-    /// This function instantiates a \ref DistMap.
-    /// \param g is the digraph to which we would like to define the
+    /// This function instantiates a \ref DistMap. 
+    /// \param g is the digraph to which we would like to define the 
     /// \ref DistMap.
     static DistMap *createDistMap(const GR& g) {
@@ -145,11 +144,11 @@
 
   };
-
+  
   /// \brief %BellmanFord algorithm class.
   ///
   /// \ingroup shortest_path
-  /// This class provides an efficient implementation of the Bellman-Ford
+  /// This class provides an efficient implementation of the Bellman-Ford 
   /// algorithm. The maximum time complexity of the algorithm is
-  /// <tt>O(nm)</tt>.
+  /// <tt>O(ne)</tt>.
   ///
   /// The Bellman-Ford algorithm solves the single-source shortest path
@@ -160,5 +159,5 @@
   ///
   /// The arc lengths are passed to the algorithm using a
-  /// \ref concepts::ReadMap "ReadMap", so it is easy to change it to any
+  /// \ref concepts::ReadMap "ReadMap", so it is easy to change it to any 
   /// kind of length. The type of the length values is determined by the
   /// \ref concepts::ReadMap::Value "Value" type of the length map.
@@ -173,9 +172,4 @@
   /// the lengths of the arcs. The default map type is
   /// \ref concepts::Digraph::ArcMap "GR::ArcMap<int>".
-  /// \tparam TR The traits class that defines various types used by the
-  /// algorithm. By default, it is \ref BellmanFordDefaultTraits
-  /// "BellmanFordDefaultTraits<GR, LEN>".
-  /// In most cases, this parameter should not be set directly,
-  /// consider to use the named template parameters instead.
 #ifdef DOXYGEN
   template <typename GR, typename LEN, typename TR>
@@ -190,5 +184,5 @@
     ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
-
+    
     /// \brief The type of the arc lengths.
     typedef typename TR::LengthMap::Value Value;
@@ -202,10 +196,9 @@
     /// The type of the paths.
     typedef PredMapPath<Digraph, PredMap> Path;
-    ///\brief The \ref lemon::BellmanFordDefaultOperationTraits
+    ///\brief The \ref BellmanFordDefaultOperationTraits
     /// "operation traits class" of the algorithm.
     typedef typename TR::OperationTraits OperationTraits;
 
-    ///\brief The \ref lemon::BellmanFordDefaultTraits "traits class"
-    ///of the algorithm.
+    ///The \ref BellmanFordDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
@@ -238,10 +231,10 @@
     void create_maps() {
       if(!_pred) {
-        _local_pred = true;
-        _pred = Traits::createPredMap(*_gr);
+	_local_pred = true;
+	_pred = Traits::createPredMap(*_gr);
       }
       if(!_dist) {
-        _local_dist = true;
-        _dist = Traits::createDistMap(*_gr);
+	_local_dist = true;
+	_dist = Traits::createDistMap(*_gr);
       }
       if(!_mask) {
@@ -249,7 +242,7 @@
       }
     }
-
+    
   public :
-
+ 
     typedef BellmanFord Create;
 
@@ -274,9 +267,9 @@
     /// It must conform to the \ref concepts::WriteMap "WriteMap" concept.
     template <class T>
-    struct SetPredMap
+    struct SetPredMap 
       : public BellmanFord< Digraph, LengthMap, SetPredMapTraits<T> > {
       typedef BellmanFord< Digraph, LengthMap, SetPredMapTraits<T> > Create;
     };
-
+    
     template <class T>
     struct SetDistMapTraits : public Traits {
@@ -295,5 +288,5 @@
     /// It must conform to the \ref concepts::WriteMap "WriteMap" concept.
     template <class T>
-    struct SetDistMap
+    struct SetDistMap 
       : public BellmanFord< Digraph, LengthMap, SetDistMapTraits<T> > {
       typedef BellmanFord< Digraph, LengthMap, SetDistMapTraits<T> > Create;
@@ -304,6 +297,6 @@
       typedef T OperationTraits;
     };
-
-    /// \brief \ref named-templ-param "Named parameter" for setting
+    
+    /// \brief \ref named-templ-param "Named parameter" for setting 
     /// \c OperationTraits type.
     ///
@@ -317,13 +310,13 @@
       Create;
     };
-
+    
     ///@}
 
   protected:
-
+    
     BellmanFord() {}
 
-  public:
-
+  public:      
+    
     /// \brief Constructor.
     ///
@@ -335,5 +328,5 @@
       _pred(0), _local_pred(false),
       _dist(0), _local_dist(false), _mask(0) {}
-
+    
     ///Destructor.
     ~BellmanFord() {
@@ -362,6 +355,6 @@
     BellmanFord &predMap(PredMap &map) {
       if(_local_pred) {
-        delete _pred;
-        _local_pred=false;
+	delete _pred;
+	_local_pred=false;
       }
       _pred = &map;
@@ -380,6 +373,6 @@
     BellmanFord &distMap(DistMap &map) {
       if(_local_dist) {
-        delete _dist;
-        _local_dist=false;
+	delete _dist;
+	_local_dist=false;
       }
       _dist = &map;
@@ -399,5 +392,5 @@
 
     /// \brief Initializes the internal data structures.
-    ///
+    /// 
     /// Initializes the internal data structures. The optional parameter
     /// is the initial distance of each node.
@@ -405,20 +398,20 @@
       create_maps();
       for (NodeIt it(*_gr); it != INVALID; ++it) {
-        _pred->set(it, INVALID);
-        _dist->set(it, value);
+	_pred->set(it, INVALID);
+	_dist->set(it, value);
       }
       _process.clear();
       if (OperationTraits::less(value, OperationTraits::infinity())) {
-        for (NodeIt it(*_gr); it != INVALID; ++it) {
-          _process.push_back(it);
-          _mask->set(it, true);
-        }
+	for (NodeIt it(*_gr); it != INVALID; ++it) {
+	  _process.push_back(it);
+	  _mask->set(it, true);
+	}
       } else {
-        for (NodeIt it(*_gr); it != INVALID; ++it) {
-          _mask->set(it, false);
-        }
-      }
-    }
-
+	for (NodeIt it(*_gr); it != INVALID; ++it) {
+	  _mask->set(it, false);
+	}
+      }
+    }
+    
     /// \brief Adds a new source node.
     ///
@@ -428,6 +421,6 @@
       _dist->set(source, dst);
       if (!(*_mask)[source]) {
-        _process.push_back(source);
-        _mask->set(source, true);
+	_process.push_back(source);
+	_mask->set(source, true);
       }
     }
@@ -454,24 +447,24 @@
     bool processNextRound() {
       for (int i = 0; i < int(_process.size()); ++i) {
-        _mask->set(_process[i], false);
+	_mask->set(_process[i], false);
       }
       std::vector<Node> nextProcess;
       std::vector<Value> values(_process.size());
       for (int i = 0; i < int(_process.size()); ++i) {
-        values[i] = (*_dist)[_process[i]];
+	values[i] = (*_dist)[_process[i]];
       }
       for (int i = 0; i < int(_process.size()); ++i) {
-        for (OutArcIt it(*_gr, _process[i]); it != INVALID; ++it) {
-          Node target = _gr->target(it);
-          Value relaxed = OperationTraits::plus(values[i], (*_length)[it]);
-          if (OperationTraits::less(relaxed, (*_dist)[target])) {
-            _pred->set(target, it);
-            _dist->set(target, relaxed);
-            if (!(*_mask)[target]) {
-              _mask->set(target, true);
-              nextProcess.push_back(target);
-            }
-          }
-        }
+	for (OutArcIt it(*_gr, _process[i]); it != INVALID; ++it) {
+	  Node target = _gr->target(it);
+	  Value relaxed = OperationTraits::plus(values[i], (*_length)[it]);
+	  if (OperationTraits::less(relaxed, (*_dist)[target])) {
+	    _pred->set(target, it);
+	    _dist->set(target, relaxed);
+	    if (!(*_mask)[target]) {
+	      _mask->set(target, true);
+	      nextProcess.push_back(target);
+	    }
+	  }	  
+	}
       }
       _process.swap(nextProcess);
@@ -495,21 +488,21 @@
     bool processNextWeakRound() {
       for (int i = 0; i < int(_process.size()); ++i) {
-        _mask->set(_process[i], false);
+	_mask->set(_process[i], false);
       }
       std::vector<Node> nextProcess;
       for (int i = 0; i < int(_process.size()); ++i) {
-        for (OutArcIt it(*_gr, _process[i]); it != INVALID; ++it) {
-          Node target = _gr->target(it);
-          Value relaxed =
-            OperationTraits::plus((*_dist)[_process[i]], (*_length)[it]);
-          if (OperationTraits::less(relaxed, (*_dist)[target])) {
-            _pred->set(target, it);
-            _dist->set(target, relaxed);
-            if (!(*_mask)[target]) {
-              _mask->set(target, true);
-              nextProcess.push_back(target);
-            }
-          }
-        }
+	for (OutArcIt it(*_gr, _process[i]); it != INVALID; ++it) {
+	  Node target = _gr->target(it);
+	  Value relaxed = 
+	    OperationTraits::plus((*_dist)[_process[i]], (*_length)[it]);
+	  if (OperationTraits::less(relaxed, (*_dist)[target])) {
+	    _pred->set(target, it);
+	    _dist->set(target, relaxed);
+	    if (!(*_mask)[target]) {
+	      _mask->set(target, true);
+	      nextProcess.push_back(target);
+	    }
+	  }	  
+	}
       }
       _process.swap(nextProcess);
@@ -533,5 +526,5 @@
       int num = countNodes(*_gr) - 1;
       for (int i = 0; i < num; ++i) {
-        if (processNextWeakRound()) break;
+	if (processNextWeakRound()) break;
       }
     }
@@ -545,16 +538,16 @@
     /// if the digraph contains cycles with negative total length.
     ///
-    /// The algorithm computes
+    /// The algorithm computes 
     /// - the shortest path tree (forest),
     /// - the distance of each node from the root(s).
-    ///
+    /// 
     /// \return \c false if there is a negative cycle in the digraph.
     ///
     /// \pre init() must be called and at least one root node should be
-    /// added with addSource() before using this function.
+    /// added with addSource() before using this function. 
     bool checkedStart() {
       int num = countNodes(*_gr);
       for (int i = 0; i < num; ++i) {
-        if (processNextWeakRound()) return true;
+	if (processNextWeakRound()) return true;
       }
       return _process.empty();
@@ -580,13 +573,13 @@
     ///
     /// \pre init() must be called and at least one root node should be
-    /// added with addSource() before using this function.
+    /// added with addSource() before using this function. 
     void limitedStart(int num) {
       for (int i = 0; i < num; ++i) {
-        if (processNextRound()) break;
-      }
-    }
-
+	if (processNextRound()) break;
+      }
+    }
+    
     /// \brief Runs the algorithm from the given root node.
-    ///
+    ///    
     /// This method runs the Bellman-Ford algorithm from the given root
     /// node \c s in order to compute the shortest path to each node.
@@ -607,8 +600,8 @@
       start();
     }
-
+    
     /// \brief Runs the algorithm from the given root node with arc
     /// number limit.
-    ///
+    ///    
     /// This method runs the Bellman-Ford algorithm from the given root
     /// node \c s in order to compute the shortest path distance for each
@@ -636,5 +629,5 @@
       limitedStart(num);
     }
-
+    
     ///@}
 
@@ -651,5 +644,5 @@
       ///
       /// Constructor for getting the active nodes of the given BellmanFord
-      /// instance.
+      /// instance. 
       ActiveIt(const BellmanFord& algorithm) : _algorithm(&algorithm)
       {
@@ -665,5 +658,5 @@
       ///
       /// Conversion to \c Node.
-      operator Node() const {
+      operator Node() const { 
         return _index >= 0 ? _algorithm->_process[_index] : INVALID;
       }
@@ -674,46 +667,31 @@
       ActiveIt& operator++() {
         --_index;
-        return *this;
-      }
-
-      bool operator==(const ActiveIt& it) const {
-        return static_cast<Node>(*this) == static_cast<Node>(it);
-      }
-      bool operator!=(const ActiveIt& it) const {
-        return static_cast<Node>(*this) != static_cast<Node>(it);
-      }
-      bool operator<(const ActiveIt& it) const {
-        return static_cast<Node>(*this) < static_cast<Node>(it);
-      }
-
+        return *this; 
+      }
+
+      bool operator==(const ActiveIt& it) const { 
+        return static_cast<Node>(*this) == static_cast<Node>(it); 
+      }
+      bool operator!=(const ActiveIt& it) const { 
+        return static_cast<Node>(*this) != static_cast<Node>(it); 
+      }
+      bool operator<(const ActiveIt& it) const { 
+        return static_cast<Node>(*this) < static_cast<Node>(it); 
+      }
+      
     private:
       const BellmanFord* _algorithm;
       int _index;
     };
-
-    /// \brief Gets the collection of the active nodes.
-    ///
-    /// This function can be used for iterating on the active nodes of the
-    /// Bellman-Ford algorithm after the last phase.
-    /// These nodes should be checked in the next phase to
-    /// find augmenting arcs outgoing from them.
-    /// It returns a wrapped ActiveIt, which looks
-    /// like an STL container (by having begin() and end())
-    /// which you can use in range-based for loops, STL algorithms, etc.
-    LemonRangeWrapper1<ActiveIt, BellmanFord>
-    activeNodes() const {
-      return LemonRangeWrapper1<ActiveIt, BellmanFord>(*this);
-    }
-
-
+    
     /// \name Query Functions
     /// The result of the Bellman-Ford algorithm can be obtained using these
     /// functions.\n
     /// Either \ref run() or \ref init() should be called before using them.
-
+    
     ///@{
 
     /// \brief The shortest path to the given node.
-    ///
+    ///    
     /// Gives back the shortest path to the given node from the root(s).
     ///
@@ -726,5 +704,5 @@
       return Path(*_gr, *_pred, t);
     }
-
+	  
     /// \brief The distance of the given node from the root(s).
     ///
@@ -766,8 +744,8 @@
     /// \pre Either \ref run() or \ref init() must be called before
     /// using this function.
-    Node predNode(Node v) const {
-      return (*_pred)[v] == INVALID ? INVALID : _gr->source((*_pred)[v]);
-    }
-
+    Node predNode(Node v) const { 
+      return (*_pred)[v] == INVALID ? INVALID : _gr->source((*_pred)[v]); 
+    }
+    
     /// \brief Returns a const reference to the node map that stores the
     /// distances of the nodes.
@@ -779,5 +757,5 @@
     /// using this function.
     const DistMap &distMap() const { return *_dist;}
-
+ 
     /// \brief Returns a const reference to the node map that stores the
     /// predecessor arcs.
@@ -789,5 +767,5 @@
     /// using this function.
     const PredMap &predMap() const { return *_pred; }
-
+ 
     /// \brief Checks if a node is reached from the root(s).
     ///
@@ -801,5 +779,5 @@
 
     /// \brief Gives back a negative cycle.
-    ///
+    ///    
     /// This function gives back a directed cycle with negative total
     /// length if the algorithm has already found one.
@@ -828,8 +806,8 @@
       return cycle;
     }
-
+    
     ///@}
   };
-
+ 
   /// \brief Default traits class of bellmanFord() function.
   ///
@@ -839,5 +817,5 @@
   template <typename GR, typename LEN>
   struct BellmanFordWizardDefaultTraits {
-    /// The type of the digraph the algorithm runs on.
+    /// The type of the digraph the algorithm runs on. 
     typedef GR Digraph;
 
@@ -860,5 +838,5 @@
     /// \brief The type of the map that stores the last
     /// arcs of the shortest paths.
-    ///
+    /// 
     /// The type of the map that stores the last arcs of the shortest paths.
     /// It must conform to the \ref concepts::WriteMap "WriteMap" concept.
@@ -866,5 +844,5 @@
 
     /// \brief Instantiates a \c PredMap.
-    ///
+    /// 
     /// This function instantiates a \ref PredMap.
     /// \param g is the digraph to which we would like to define the
@@ -882,5 +860,5 @@
     /// \brief Instantiates a \c DistMap.
     ///
-    /// This function instantiates a \ref DistMap.
+    /// This function instantiates a \ref DistMap. 
     /// \param g is the digraph to which we would like to define the
     /// \ref DistMap.
@@ -895,5 +873,5 @@
     typedef lemon::Path<Digraph> Path;
   };
-
+  
   /// \brief Default traits class used by BellmanFordWizard.
   ///
@@ -902,5 +880,5 @@
   /// \tparam LEN The type of the length map.
   template <typename GR, typename LEN>
-  class BellmanFordWizardBase
+  class BellmanFordWizardBase 
     : public BellmanFordWizardDefaultTraits<GR, LEN> {
 
@@ -925,5 +903,5 @@
     public:
     /// Constructor.
-
+    
     /// This constructor does not require parameters, it initiates
     /// all of the attributes to default values \c 0.
@@ -932,17 +910,17 @@
 
     /// Constructor.
-
+    
     /// This constructor requires two parameters,
     /// others are initiated to \c 0.
     /// \param gr The digraph the algorithm runs on.
     /// \param len The length map.
-    BellmanFordWizardBase(const GR& gr,
-                          const LEN& len) :
-      _graph(reinterpret_cast<void*>(const_cast<GR*>(&gr))),
-      _length(reinterpret_cast<void*>(const_cast<LEN*>(&len))),
+    BellmanFordWizardBase(const GR& gr, 
+			  const LEN& len) :
+      _graph(reinterpret_cast<void*>(const_cast<GR*>(&gr))), 
+      _length(reinterpret_cast<void*>(const_cast<LEN*>(&len))), 
       _pred(0), _dist(0), _path(0), _di(0) {}
 
   };
-
+  
   /// \brief Auxiliary class for the function-type interface of the
   /// \ref BellmanFord "Bellman-Ford" algorithm.
@@ -956,7 +934,4 @@
   /// This class should only be used through the \ref bellmanFord()
   /// function, which makes it easier to use the algorithm.
-  ///
-  /// \tparam TR The traits class that defines various types used by the
-  /// algorithm.
   template<class TR>
   class BellmanFordWizard : public TR {
@@ -969,5 +944,5 @@
     typedef typename Digraph::Arc Arc;
     typedef typename Digraph::OutArcIt ArcIt;
-
+    
     typedef typename TR::LengthMap LengthMap;
     typedef typename LengthMap::Value Value;
@@ -986,5 +961,5 @@
     /// \param gr The digraph the algorithm runs on.
     /// \param len The length map.
-    BellmanFordWizard(const Digraph& gr, const LengthMap& len)
+    BellmanFordWizard(const Digraph& gr, const LengthMap& len) 
       : TR(gr, len) {}
 
@@ -995,10 +970,10 @@
 
     /// \brief Runs the Bellman-Ford algorithm from the given source node.
-    ///
+    ///    
     /// This method runs the Bellman-Ford algorithm from the given source
     /// node in order to compute the shortest path to each node.
     void run(Node s) {
-      BellmanFord<Digraph,LengthMap,TR>
-        bf(*reinterpret_cast<const Digraph*>(Base::_graph),
+      BellmanFord<Digraph,LengthMap,TR> 
+	bf(*reinterpret_cast<const Digraph*>(Base::_graph), 
            *reinterpret_cast<const LengthMap*>(Base::_length));
       if (Base::_pred) bf.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
@@ -1035,5 +1010,5 @@
       SetPredMapBase(const TR &b) : TR(b) {}
     };
-
+    
     /// \brief \ref named-templ-param "Named parameter" for setting
     /// the predecessor map.
@@ -1046,5 +1021,5 @@
       return BellmanFordWizard<SetPredMapBase<T> >(*this);
     }
-
+    
     template<class T>
     struct SetDistMapBase : public Base {
@@ -1053,5 +1028,5 @@
       SetDistMapBase(const TR &b) : TR(b) {}
     };
-
+    
     /// \brief \ref named-templ-param "Named parameter" for setting
     /// the distance map.
@@ -1094,7 +1069,7 @@
       return *this;
     }
-
+    
   };
-
+  
   /// \brief Function type interface for the \ref BellmanFord "Bellman-Ford"
   /// algorithm.
@@ -1104,6 +1079,6 @@
   /// algorithm.
   ///
-  /// This function also has several \ref named-templ-func-param
-  /// "named parameters", they are declared as the members of class
+  /// This function also has several \ref named-templ-func-param 
+  /// "named parameters", they are declared as the members of class 
   /// \ref BellmanFordWizard.
   /// The following examples show how to use these parameters.
@@ -1122,5 +1097,5 @@
   BellmanFordWizard<BellmanFordWizardBase<GR,LEN> >
   bellmanFord(const GR& digraph,
-              const LEN& length)
+	      const LEN& length)
   {
     return BellmanFordWizard<BellmanFordWizardBase<GR,LEN> >(digraph, length);
Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 1270)
+++ lemon/bfs.h	(revision 835)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -83,6 +83,5 @@
 
     ///The type of the map that indicates which nodes are reached.
-    ///It must conform to
-    ///the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must conform to the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
     ///Instantiates a \c ReachedMap.
@@ -123,9 +122,4 @@
   ///\tparam GR The type of the digraph the algorithm runs on.
   ///The default type is \ref ListDigraph.
-  ///\tparam TR The traits class that defines various types used by the
-  ///algorithm. By default, it is \ref BfsDefaultTraits
-  ///"BfsDefaultTraits<GR>".
-  ///In most cases, this parameter should not be set directly,
-  ///consider to use the named template parameters instead.
 #ifdef DOXYGEN
   template <typename GR,
@@ -153,5 +147,5 @@
     typedef PredMapPath<Digraph, PredMap> Path;
 
-    ///The \ref lemon::BfsDefaultTraits "traits class" of the algorithm.
+    ///The \ref BfsDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
@@ -273,6 +267,5 @@
     ///\ref named-templ-param "Named parameter" for setting
     ///\c ReachedMap type.
-    ///It must conform to
-    ///the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must conform to the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
     template <class T>
     struct SetReachedMap : public Bfs< Digraph, SetReachedMapTraits<T> > {
@@ -875,6 +868,5 @@
 
     ///The type of the map that indicates which nodes are reached.
-    ///It must conform to
-    ///the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must conform to the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
     ///Instantiates a ReachedMap.
@@ -966,7 +958,4 @@
   /// This class should only be used through the \ref bfs() function,
   /// which makes it easier to use the algorithm.
-  ///
-  /// \tparam TR The traits class that defines various types used by the
-  /// algorithm.
   template<class TR>
   class BfsWizard : public TR
@@ -1252,5 +1241,4 @@
       }
       _Visitor& visitor;
-      Constraints() {}
     };
   };
@@ -1270,6 +1258,5 @@
     ///
     /// The type of the map that indicates which nodes are reached.
-    /// It must conform to
-    ///the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    /// It must conform to the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
 
@@ -1309,9 +1296,9 @@
   /// does not observe the BFS events. If you want to observe the BFS
   /// events, you should implement your own visitor class.
-  /// \tparam TR The traits class that defines various types used by the
-  /// algorithm. By default, it is \ref BfsVisitDefaultTraits
-  /// "BfsVisitDefaultTraits<GR>".
-  /// In most cases, this parameter should not be set directly,
-  /// consider to use the named template parameters instead.
+  /// \tparam TR Traits class to set various data types used by the
+  /// algorithm. The default traits class is
+  /// \ref BfsVisitDefaultTraits "BfsVisitDefaultTraits<GR>".
+  /// See \ref BfsVisitDefaultTraits for the documentation of
+  /// a BFS visit traits class.
 #ifdef DOXYGEN
   template <typename GR, typename VS, typename TR>
Index: lemon/bin_heap.h
===================================================================
--- lemon/bin_heap.h	(revision 1270)
+++ lemon/bin_heap.h	(revision 758)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
